Revit Platform API Changes and Additions
Revit Platform API Changes and Additions
If the addon still needs to specify a security protocol or its version, do not hard-code it exclusively, e.g.
by directly assigning the protocol/version to the application-wide property
ServicePointManager.SecurityProtocol. This will override Revit’s native TLS configuration, which is critical
for Revit to communicate with various Autodesk cloud services. A problematic setting is like
System.Net.ServicePointManager.SecurityProtocol =
System.Net.SecurityProtocolType.Tls12;
Instead you need to specify the protocol/version inclusively, e.g. by using bitwise OR (logical OR) on the
application-wide property ServicePointManager.SecurityProtocol. A correct setting is like
System.Net.ServicePointManager.SecurityProtocol |=
System.Net.SecurityProtocolType.Tls12;
Autodesk.Revit.DB.ForgeTypeId
represents an identifier for a unit, symbol, or other object, and is now used throughout the Revit API to
identify units of measurement, symbols, and unit types. Unit types are now referred to as "specs" to avoid
confusion with units themselves.
A ForgeTypeId instance holds a string, called a "typeid", that uniquely identifies a Forge schema. A Forge
schema is a JSON document describing a data structure, supporting data interchange between
applications. A typeid string includes a namespace and version number and may look something like
"autodesk.spec.aec:length-1.0.0" or "autodesk.unit.unit:meters-1.0.0". By default, comparison of
ForgeTypeId values in the Revit API ignores the version number.
Autodesk.Revit.DB.UnitTypeId
Autodesk.Revit.DB.SymbolTypeId
Autodesk.Revit.DB.SpecTypeId
contain a default set of named public constant properties of type ForgeTypeId. These values can be used
in code replacing values of the deprecated DisplayUnitType, UnitSymbolType, and UnitType
enumerations.
The UnitUtils class now offers a set of new methods for mapping between enumeration values and
ForgeTypeId values to assist clients in migrating code to ForgeTypeId:
UnitUtils.IsSymbol()
UnitUtils.GetSpecTypeId()
UnitUtils.GetUnitType()
UnitUtils.GetUnitTypeId()
UnitUtils.GetDisplayUnitType()
UnitUtils.GetSymbolTypeId()
UnitUtils.GetUnitSymbolType()
Some of the preceding methods are new but are already deprecated. They have been added to the API
only to assist clients in migrating code from the old enumerations to the ForgeTypeId class.
Deprecated Replacement
DisplayUnitType UnitTypeId
UnitSymbolType SymbolTypeId
UnitType SpecTypeId
Autodesk.Revit.DB.UnitUtils:
Deprecated Replacement
static double Convert(double, static double Convert(double, ForgeTypeId
DisplayUnitType, DisplayUnitType) currentUnitTypeId, ForgeTypeId desiredUnitTypeId)
static double
static double ConvertFromInternalUnits(double,
ConvertFromInternalUnits(double,
ForgeTypeId unitTypeId)
DisplayUnitType)
static double ConvertToInternalUnits(double, static double ConvertToInternalUnits(double,
DisplayUnitType) ForgeTypeId unitTypeId)
static bool IsValidDisplayUnit(DisplayUnitType) static bool IsUnit(ForgeTypeId unitTypeId)
static List<DisplayUnitType>
static List<ForgeTypeId> GetAllUnits()
GetValidDisplayUnits()
static bool IsValidDisplayUnit(UnitType, static bool IsValidUnit(ForgeTypeId specTypeId,
DisplayUnitType) ForgeTypeId unitTypeId)
static List<DisplayUnitType> static List<ForgeTypeId> GetValidUnits(ForgeTypeId
GetValidDisplayUnits(UnitType) specTypeId)
static string static string GetTypeCatalogStringForUnit(ForgeTypeId
GetTypeCatalogString(DisplayUnitType) unitTypeId)
static bool IsValidUnitType(UnitType) static bool IsSpec(ForgeTypeId specTypeId)
static List<UnitType> GetValidUnitTypes() static List<ForgeTypeId> GetAllSpecs()
static UnitGroup GetUnitGroup(UnitType) static UnitGroup GetUnitGroup(ForgeTypeId specTypeId)
static string GetTypeCatalogStringForSpec(ForgeTypeId
static string GetTypeCatalogString(UnitType)
specTypeId)
Autodesk.Revit.DB.ExtensibleStorage.Entity:
Deprecated Replacement
FieldType Get(Field, DisplayUnitType) FieldType Get(Field, ForgeTypeId unitTypeId)
FieldType Get(string, DisplayUnitType) FieldType Get(string, ForgeTypeId unitTypeId)
void Set(Field, FieldType, DisplayUnitType) void Set(Field, FieldType, ForgeTypeId unitTypeId)
void Set(string, FieldType, DisplayUnitType) void Set(string, FieldType, ForgeTypeId unitTypeId)
Autodesk.Revit.DB.FamilyParameter:
Deprecated Replacement
property DisplayUnitType DisplayUnitType (get) ForgeTypeId GetUnitTypeId()
Autodesk.Revit.DB.Parameter:
Deprecated Replacement
property DisplayUnitType DisplayUnitType (get) ForgeTypeId GetUnitTypeId()
Autodesk.Revit.DB.Definition:
Deprecated Replacement
property UnitType UnitType (get) ForgeTypeId GetSpecTypeId()
Autodesk.Revit.DB.Visual.AssetPropertyDistance:
Deprecated Replacement
property DisplayUnitType DisplayUnitType (get) ForgeTypeId GetUnitTypeId()
Autodesk.Revit.DB.Units:
Deprecated Replacement
FormatOptions GetFormatOptions(ForgeTypeId
FormatOptions GetFormatOptions(UnitType)
specTypeId)
void SetFormatOptions(UnitType, void SetFormatOptions(ForgeTypeId specTypeId,
FormatOptions) FormatOptions)
static bool IsModifiableUnitType(UnitType) static bool IsModifiableSpec(ForgeTypeId specTypeId)
static List<UnitType>
static List<ForgeTypeId> GetModifiableSpecs()
GetModifiableUnitTypes()
Autodesk.Revit.DB.DimensionType:
Deprecated Replacement
property UnitType UnitType (get) ForgeTypeId GetSpecTypeId()
Autodesk.Revit.DB.ExtensibleStorage.Field:
Deprecated Replacement
bool CompatibleDisplayUnitType(DisplayUnitType) bool CompatibleUnit(ForgeTypeId unitTypeId)
property UnitType UnitType (get) ForgeTypeId GetSpecTypeId()
Autodesk.Revit.DB.ExtensibleStorage.FieldBuilder:
Deprecated Replacement
FieldBuilder SetUnitType(UnitType) FieldBuilder SetSpec(ForgeTypeId specTypeId)
Autodesk.Revit.DB.FamilySizeTableColumn:
Deprecated Replacement
property DisplayUnitType DisplayUnitType (get) ForgeTypeId GetUnitTypeId()
property UnitType UnitType (get) ForgeTypeId GetSpecTypeId()
Autodesk.Revit.DB.FormatOptions:
Deprecated Replacement
FormatOptions(DisplayUnitType) FormatOptions(ForgeTypeId unitTypeId)
FormatOptions(ForgeTypeId unitTypeId,
FormatOptions(DisplayUnitType, UnitSymbolType)
ForgeTypeId symbolTypeId)
This constructor has not been replaced. Please use
FormatOptions(DisplayUnitType, double)
property assignment to set the accuracy.
FormatOptions(DisplayUnitType, UnitSymbolType, This constructor has not been replaced. Please use
double) property assignment to set the accuracy.
ForgeTypeId GetUnitTypeId()
property DisplayUnitType DisplayUnits (get/set)
void SetUnitTypeId(ForgeTypeId unitTypeId)
ForgeTypeId GetSymbolTypeId()
Autodesk.Revit.DB.LabelUtils:
Deprecated Replacement
static string GetLabelFor(DisplayUnitType) static string GetLabelForUnit(ForgeTypeId unitTypeId)
static string GetLabelFor(UnitSymbolType) static string GetLabelForSymbol(ForgeTypeId symbolTypeId)
static string GetLabelFor(UnitType) static string GetLabelForSpec(ForgeTypeId specTypeId)
Autodesk.Revit.DB.Structure.ReinforcementRoundingManager:
Deprecated Replacement
property DisplayUnitType LengthDisplayUnit (get) ForgeTypeId GetLengthUnitTypeId()
Autodesk.Revit.DB.ScheduleField:
Deprecated Replacement
property UnitType UnitType (get) ForgeTypeId GetSpecTypeId()
Autodesk.Revit.DB.TableSectionData:
Deprecated Replacement
UnitType GetCellUnitType(int, int) ForgeTypeId GetCellSpec(int, int)
Autodesk.Revit.DB.UnitFormatUtils:
Deprecated Replacement
static string Format(Units, UnitType, static string Format(Units, ForgeTypeId specTypeId,
double, bool, bool, FormatValueOptions) double, bool, FormatValueOptions)
static string Format(Units, UnitType, Note: The "maxAccuracy" option has not been
replaced. Please specify the desired precision
double, bool, FormatValueOptions)
explicitly.
static string Format(Units, UnitType, Note: The "maxAccuracy" option has not been
double, bool) replaced. Please specify the desired precision
explicitly.
static bool TryParse(Units, UnitType, string, static bool TryParse(Units, ForgeTypeId specTypeId,
ValueParsingOptions, double) string, ValueParsingOptions, double)
static bool TryParse(Units, UnitType, string, static bool TryParse(Units, ForgeTypeId specTypeId,
ValueParsingOptions, double, string) string, ValueParsingOptions, double, string)
static bool TryParse(Units, UnitType, string, static bool TryParse(Units, ForgeTypeId specTypeId,
double) string, double)
static bool TryParse(Units, UnitType, string, static bool TryParse(Units, ForgeTypeId specTypeId,
double, string) string, double, string)
The following two enum values have been removed (with no replacement):
DisplayStyle.Raytrace
TemporaryViewMode.Raytrace
ViewSchedule.ExportSchedule()
now exports a text filed formatted in UTF8 (it was previously UNICODE) for better scalability and a more
modern text format.
Slanted Walls
Standard walls can now be slanted. There is no special API for this - use the standard parameter API to
access the properties that control the slanted. API code should no longer assume that standard walls (or
their inserts) are vertical.
Autodesk.Revit.DB.Analysis.PathOfTravelCalculationRequestType
is not used in public API members and thus has been deprecated (with no replacement).
Geometry API changes
The following methods have been deprecated and replaced:
Replaced member
RBS_ENERGY_ANALYSIS_BUILDING_ENVELOPE_ANALYTICAL_SURFACE_INDENTIFICATION_RESOLUTION RBS
RBS_ENERGY_ANALYSIS_BUILDING_ENVELOPE_ANALYTICAL_SPACE_INDENTIFICATION_RESOLUTION RBS
Classes
Autodesk.Revit.DB.ImageImportOptions
Methods
ExternalResourceBrowserData.GetSubFolders()
ImageView.Create(Document, String)
Autodesk.Revit.Creation.Application.NewImageImportOptions()
StructuralConnectionHandler.GetSubPartIds()
FabricationConfiguration.GetMaterialThickness()
API additions
Systems Analysis API additions
Mechanical Analytical Systems
The new class:
Autodesk.Revit.DB.Mechanical.MEPAnalyticalSystem
represents an HVAC analytical system element where the air or water is circulated to satisfy building
energy requirements. Its AnalyticalSystemDomain property indicates whether the element represents a
water loop or air system.
Autodesk.Revit.DB.Mechanical.WaterLoopData
contains the data for a water loop system. It can be obtained from the
MEPAnalyticalSystem.GetWaterLoopData() method. It offers the following properties:
WaterLoopData.WaterLoopType
WaterLoopData.ChillerType
WaterLoopData.CondenserWaterLoopId
Autodesk.Revit.DB.Mechanical.AirSystemData
contains the data for an air system. It can be obtained from the
MEPAnalyticalSystem.GetAirSystemData() method. It offers the following properties:
AirSystemData.HeatExchangerType
AirSystemData.PreheatCoilType
AirSystemData.HeatingCoilType
AirSystemData.AirSystemCoolingCoilType
AirSystemData.AirFanType
Zone equipment
The new class:
Autodesk.Revit.DB.Mechanical.ZoneEquipment
represents a zone equipment element used for Mechanical Systems Analysis. Zone equipment is an
early-stage equipment placeholder that provides heating or cooling to part of the air system or water loop.
One zone equipment element may be mapped to multiple pieces of physical equipment depending on the
zoning behavior type.
Analytical spaces may be associated to one or more zone equipment elements. The method:
ZoneEquipment.MoveSpaceToEquipment()
moves a set of spaces from the original zone equipment to the targeted zone equipment. Either zone
equipment id may be InvalidElementId. If the original is InvalidElementId, the association is copied to the
target zone equipment. If the target is InvalidElementId, the original association is removed. The method:
ZoneEquipment.GetAssociatedZoneEquipment()
returns the set of zone equipment that is associated with the specified analytical space or spaces.
Autodesk.Revit.DB.Mechanical.ZoneEquipmentData
represents the data associated with a zone equipment. It can be obtained from the
ZoneEquipment.GetZoneEquipmentData() method. It offers the following properties:
ZoneEquipmentData.EquipmentType
ZoneEquipmentData.EquipmentBehavior
ZoneEquipmentData.HotWaterLoopId
ZoneEquipmentData.ChilledWaterLoopId
ZoneEquipmentData.AirSystemId
System-Zones
A system-zone in Revit is used to specify what parts of a building are served by specific equipment, air
systems and water loops, without having to physically model them. In the Revit API, a system-zone is
represented as a GenericZone element with a domain data of type SystemZoneData.
Autodesk.Revit.DB.GenericZone
provides for a method of selecting elements that somehow come in contact with the zone object. A zone
is a non-hierarchical structure of geometric information, area or volume definitions for the purpose of
analysis. A generic zone will contain specific domain requirements provided at creation of the element.
Currently, all GenericZones will represent system-zone elements used for MEP design. Some relevant
new members of GenericZones include:
For system-zone elements, the domain data will be an instance of the new class:
Autodesk.Revit.DB.SystemZoneData
This data includes a reference to the zone equipment for the spaces in this system-zone:
SystemZoneData.ZoneEquipmentId
Autodesk.Revit.DB.Analysis.ViewSystemsAnalysisReport
represents a view instance of the systems analysis report. In a typical API workflow, to run a systems
analysis against a Revit project, create (via ViewSystemsAnalysisReport.Create()) a new view instance
and request (via ViewSystemsAnalysisReport.RequestSystemsAnalysis()) the systems analysis from that
view. The analysis will run in the background, and when the analysis is completed, the related views are
automatically updated. The method RequestSystemsAnalysis.IsAnalysisCompleted indicates if the
background systems analysis has completed or not.
It is possible for a project to contain multiple systems analysis reports. The method:
ViewSystemsAnalysisReport.GetLatestSystemsAnalysisReport()
returns the latest report of systems analysis. The peak heating/cooling loads of all EnergyAnalysisSpace
elements should be consistent with this latest report.
Autodesk.Revit.DB.Analysis.SystemsAnalysisOptions
contains some properties (e.g., WeatherFile, WorkflowFile, and OutputFolder) that affect the systems
analysis. It is okay to leave some parameters empty. In those cases, the analysis will take the default
value from the ViewSystemsAnalsisReport element. The weather file affects the results of energy
simulation. More weather files are available at http://energyplus.net/weather .
Export to gbXML
The new property:
GBXMLExportOptions.ExportAnalyticalSystems
should be set to true to export the analytical system related items when exporting to gbXML.
Application settings
The new methods:
Application.GetSystemsAnalysisWorkflowNames()
Application.GetSystemsAnalysisWorkflows()
Application.SetSystemsAnalysisWorkflows()
allow you to read and specify the name and path information names for systems analysis workflows.
Autodesk.Revit.DB.Electrical.CircuitNamingScheme
represents a scheme used for electrical circuit naming. The most significant new methods on this class
include:
CircuitNamingScheme.Create()
CircuitNamingScheme.GetCombinedParameters()
CircuitNamingScheme.SetCombinedParameters()
allowing schemes to be created, and allowing access to the list of combined parameters associated with
the scheme.
represents the circuit naming scheme settings object in a project document. The most significant new
members on this class include:
CircuitNamingSchemeSettings.GetCircuitNamingSchemeSettings()
CircuitNamingSchemeSettings.CircuitNamingSchemeId
Element.VersionGuid
gets an element version Guid that can be used to see whether this element has changed compared to the
previous saved or synchronized version of the document.
Element Filters
Two new element filter classes have been added for use in FilteredElementCollector and other tools
leveraging ElementFilter classes.
Autodesk.Revit.DB.ElementIdSetFilter
Autodesk.Revit.DB.VisibleInViewFilter
is a quick filter that passes elements that are most likely visible in the given view.
Application.DocumentReloadingLatest
Application.DocumentReloadedLatest
Subscribers to these events will be provided an argument object containing the path to the central model.
Document changes are permitting during both events.
DBViewSection.IsSplitSection()
ViewCropRegionShapeManager.GetSplitRegionOffset()
identify if a section view is split, and return the offset for the specified split crop region.
TemporaryViewModes.CustomTitle
TemporaryViewModes.CustomColor
TemporaryViewModes.ResetCustomization()
TemporaryViewModes.IsCustomized()
provide access to read and modify a custom temporary view mode. CustomTitle should be set to cause
the view to display the customized frame. The application is responsible to adjust the appearance of
elements in the view related to the mode.
Filters
The new methods:
View.GetIsFilterEnabled()
View.SetIsFilterEnabled()
View.GetOrderedFilters()
gets the filters applied to the view in the order they are applied.
ViewSchedule.HasStripedRows
ViewSchedule.UseStripedRowsOnSheets
provides access to read or set if a given schedule is using a striped row display, and whether that display
will be used on a sheet that displays this schedule.
ViewSchedule.GetStripedRowsColor()
ViewSchedule.SetStripedRowsColor()
get and set the color applied to the indicated part of the pattern for a schedule with striped rows.
Frozen header
The new property:
ViewSchedule.IsHeaderFrozen
PathOfTravel.IsInRevealObstaclesMode()
PathOfTravel.SetRevealObstaclesMode()
For a floor plan view, calculates paths from points inside rooms to the closests of the
destinations.
Returns the start points of the longest path(s). If multiple paths have the same longest length,
returns multiple start points.
The entire plan is divided in small tiles, and the distance to the closest destination point is
calculated for each tile center point. Only tile center points that are located in rooms in the view
are taken into account.
For a floor plan view, calculates the paths from each start point to its closest destination and
return the path end points.
The calculation is done in a floor plan with one or more destinationPoints and one or more
startPoints.
The shortest path is calculated from each start point to its corresponding closest destination.
For a floor plan view, calculates paths from each start point to its closest destinations.
Returns the path, represented by an array of XYZ points.
The calculation is done in a floor plan with one or more destinationPoints and one or more
startPoints.
The shortest path is calculated from each start point to its closest destination point.
Waypoints
The new methods:
PathOfTravel.GetWaypoints()
PathOfTravel.InsertWaypoint()
PathOfTravel.SetWaypoint()
PathOfTravel.RemoveWaypoint()
provide access to read and modify the waypoints associated to a particular PathOfTravel element.
Waypoints force the path of travel calculation to ensure that the path includes each of the specified points,
in the order specified, between the start and end points.
Autodesk.Revit.ApplicationServices.Application.ViewsExportingByContext
Autodesk.Revit.ApplicationServices.Application.ViewsExportedByContext
to be notified when Revit is just about to export, or has just exported, one or more views of the document
via an export context by CustomExporter.
Handlers of this event are permitted to make modifications to any document (including the active
document), except for documents that are currently in read-only mode.
Autodesk.Revit.DB.Events.ViewsExportingByContextEventArgs
provides information when Revit is just about to export one or more views of the document via an export
context by CustomExporter.
Autodesk.Revit.DB.Events.ViewsExportedByContextEventArgs
provides information when Revit has just exported one or more views of the document via an export
context by CustomExporter.
Autodesk.Revit.DB.ColorOptions
provides access to color settings which affect the colors applied to specific views.
The ColorOptions for the current session of Revit can be accessed via:
static ColorOptions.GetColorOptions()
Autodesk.Revit.DB.OffsetSurface
encapsulates the mathematical representation of a surface offset at a normal distance from an originating
surface.
Surface.GetBoundingBoxUV()
Autodesk.Revit.DB.CurveUV
represents the notion of a curve in the 2D parameter space of a surface in 3D space. This class includes
a utility method:
CurveUV.As3DCurveInXYPlane()
that returns a 3D curve lying in the XY plane in XYZ coordinates, representing the 2D curve with its UV
coordinates identified with XY coordinates.
Edges
The new methods:
Edge.IsFlippedOnFace(int index)
Edge.IsFlippedOnFace(Face face)
determine if the edge's topological direction on the Face is opposite to its parametric direction.
SolidUtils.FindAllEdgeEndPointsAtVertex()
which will find all EdgeEndPoints at a vertex identified by the input EdgeEndPoint.
Edge.GetCurveUV()
Calculate and (optionally) transform a 2D curve that represents the edge in the UV-parameter plane of
one of the edge's faces.
Meshes
The new members:
Mesh.GetNormal()
Mesh.GetNormals()
Mesh.DistributionOfNormals
Mesh.NumberOfNormals
Geometry utilities
The new property:
GeometryObject.Id
Autodesk.Revit.DB.MathComparisonUtils
contains a set of mathematical utilities to compare doubles, using the Revit predefined internal tolerance.
Autodesk.Revit.DB.Transform1D
Autodesk.Revit.DB.Transform2D
BoundingBoxUV.IsSet
ImageType.Resolution
ImageType.WidthInPixels
ImageType.HeightInPixels
ImageType.Width
ImageType.Height
provide read access to some of the image size and resolution properties.
ImageTypeOptions.SourceType
ImageTypeSource
ImageType.Source - Indicates how the image is created (as a link, import, or internally-generated
image)
ImageType.Status - Indicates whether the image is loaded or unloaded (if applicable)
ImageType.Unload() - Unloads a linked image
ImageTypeStatus
ModelPath.Region
returns the region of the BIM 360 account and project which contains this model.
ModelPathUtils.CloudRegionUS
ModelPathUtils.CloudRegionEMEA
return the region names of different BIM 360 cloud services. They can be used as the first argument of
the ModelPathUtils.ConvertCloudGUIDsToCloudPath() method.
OpenConflictScenario.VersionArchived
indicates that last central version merged into the local model to open has been archived in the central
model.
OpenConflictResult.DetachFromCentral
provides the option to detach the local model from its central model, with worksets preserved.
Autodesk.Revit.DB.Structure.ConnectionInputPoint
contains the 3D location and unique id for one structural connection input point.
Autodesk.Revit.DB.Structure.ConnectionInputPointInfo
contains information about connection input points requirements, such as number of required points, a
user visible description for each point, and potential location restrictions.
Autodesk.Revit.DB.Structure.StructuralConnectionHandler.Create(Document, IList<ElementId>,
ElementId, IList<XYZ>)
RebarConstraint.GetDistanceToTargetRebar()
RebarConstraint.SetDistanceToTargetRebar()
RebarConstraint.IsBindingHandleWithTarget()
RebarConstraint.SetToBindHandleWithTarget()
RebarConstraint.IsUsingClearBarSpacing()
RebarConstraint.SetToUseClearBarSpacing()
RebarConstraint.FlipHandleOverTarget()
RebarConstraintsManager.GetConstraintCandidatesForHandle(RebarConstrainedHandle,
ElementId)
RebarConstraintsManager.GetConstraintCandidatesForHandle(RebarConstrainedHandle,
Reference)
these methods return all possible RebarConstraints that could be used for a RebarConstrainedHandle
related to the additional input. For free form rebar these will return an empty list.
Rebar.SetEndTreatmentTypeId()
sets the id of the EndTreatmentType to be applied to the rebar at the specified end.
FabricSheet.IsSolidInView()
FabricSheet.SetSolidInView()
FabricSheet.IsUnobscuredInView()
FabricSheet.SetUnobscuredInView()
get and set the visibility options for a given fabric sheet instance as applied to a particular 3D view.
The following methods allow getting or setting the out of plan hook rotation angle:
Rebar.GetHookRotationAngle()
Rebar.SetHookRotationAngle()
RebarShape.GetHookRotationAngle()
RebarShape.SetHookRotationAngle()
Rebar.EnableHookLengthOverride()
Rebar.IsHookLengthOverrideEnabled()
Rebar.GetOverridableHookParameters() - Outputs the formula parameter ids defined in the
RebarShape family which are associated with hook length and hook tangent length parameters.
StructuralAsset.MetalThermallyTreated
indicates whether the asset describes a material that is thermally treated or not, corresponding to the
BuiltInParameter member PHY_MATERIAL_PARAM_STRUCTURAL_THERMAL_TREATED.
SpatialFieldManager.AllowInteractiveSettings
toggles the ability to access the Analysis Visualization Framework (AVF) settings for a particular set of
results. This property is true by default. If the property is set to false, all AVF dialogs are unreachable in
the UI.
Also, if the property is set to false, deletion of the SpatialFieldManager, its parts or associated
AnalysisDisplayLegend element is prohibited.
Autodesk.Revit.DB.InternalOrigin
represents the origin of Revit's internal coordinate system. Each Revit project contains one InternalOrigin.
static InternalOrigin.Get(Document doc) - Returns the internal origin of the project. There is one
InternalOrigin per document.
InternalOrigin.Position - Read-only property which returns the XYZ value of the internal
coordinates.
InternalOrigin.SharedPosition - Read-only property which returns the shared position of the
internal origin based on the active ProjectLocation of its Document.
BasePoint
Two new methods provide access to the base and survey point:
static BasePoint.GetProjectBasePoint()
static BasePoint.GetSurveyPoint()